/* $Id$

Copyright (C) 2010  The PARI group.

This file is part of the PARI/GP package.

PARI/GP is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation. It is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY WHATSOEVER.

Check the License for details. You should have received a copy of it, along
with the package; see the file 'COPYING'. If not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
#include "pari.h"
#include "paripriv.h"

void mt_init_stack(size_t s) { }
void mt_err_recover(long er) { }
void pari_mt_init(void) { pari_mt_nbthreads = 1; }
void pari_mt_close(void) { }

struct mt_state
{
  GEN worker;
  GEN pending;
};

void *
mt_queue_start(GEN worker)
{
  struct mt_state *mt = pari_malloc(sizeof(struct mt_state));
  mt->worker = worker;
  mt->pending = NULL;
  return (void *)mt;
}

GEN
mt_queue_get(void *p, long *pending)
{
  struct mt_state *mt = (struct mt_state *) p;
  GEN done = mt->pending;
  mt->pending = NULL; *pending = 0;
  return done;
}

void
mt_queue_submit(void *p, GEN work)
{
  struct mt_state *mt = (struct mt_state *) p;
  mt->pending = work? closure_callgenvec(mt->worker, work): NULL;
}

void
mt_queue_end(void *p)
{
  pari_free(p);
}
